#ifndef _BROKEN_H_INCLUDED_
#define _BROKEN_H_INCLUDED_

#include <zephyr.h>
#include <stdio.h>
#include <stdint.h>
#include <stdbool.h>
#include <string.h>
#include <sys/types.h>

#define DBG( _fmt, ... )  printk( "[%s] " _fmt, now(), ##__VA_ARGS__ )

// all AT commands are terminated with one of these
typedef enum
{
    AT_OK,                  // "OK"
    AT_ERROR,               // "ERROR"
    AT_CMS_ERROR,           // "+CMS:" ...
    AT_CME_ERROR,           // "+CME:" ...
}
    at_response_t;

typedef struct
{
    int sock;
    int pos;
    int buffsize;
    char buff[256];
}
    Modem;

#define MODEM_INIT { .sock = -1, .pos = 0, .buffsize = 0 }

extern int modem_open( Modem *modem );
extern void modem_close( Modem *modem );
extern char *modem_readline( Modem *modem, int timeout_ms );
extern int modem_cmd( Modem *modem, const char *cmd, int timeout_ms );
extern int modem_single_cmd( const char *buff, int timeout_ms );

extern const char *now( void );
extern void got_modem_connected( void );

#endif
